<?php
namespace Stub;
use Exception\NotImplementedException;
use Model\IUserRepository;
use Service\IAuthService;

class AuthService implements IAuthService {
    private $userRepository;

    public function __construct(UserRepository $userRepository) {
        $this->userRepository = $userRepository;
    }

    public function login($username, $password) {

        $user = $this->userRepository->getUserByUsername($username);

        if (!$user) {
            throw new \Exception('Unable to find user with that name');
        }
        if ($user->isValidPassword($password)) {
            return true;
        } 
        
        return false;
    }
    public function register(string $username, string $password, ...$data): bool
    {
        throw new NotImplementedException("register method not implemented");
        }

    public function logoutUser(): void
    {
        throw new NotImplementedException("logout method not implemented");
    }
}